# frozen_string_literal: true
require 'horn_of_plenty/version'

require 'horn_of_plenty/core_ext/string'
require 'horn_of_plenty/adapters/github/configuration'
require 'horn_of_plenty/repositories/board'
require 'horn_of_plenty/repositories/lane'
require 'horn_of_plenty/repositories/card'
require 'horn_of_plenty/repositories/issue'

module HornOfPlenty
  def self.adapter_class(name)
    adapter_classified = HornOfPlenty::CoreExt::String.camelize(name)
    adapter_class_name = "HornOfPlenty::Adapters::#{adapter_classified}"

    HornOfPlenty::CoreExt::String.constantize(adapter_class_name)
  end

  def self.adapter_config(name)
    adapter_class(name).config
  end
end
