# frozen_string_literal: true
require 'singleton'
require 'logger'

module  HornOfPlenty
module  Adapters
module  Github
  def self.configure
    yield Configuration.instance
  end

  def self.config
    return Configuration.instance unless block_given?

    yield Configuration.instance
  end

  class   Configuration
    include Singleton

    attr_accessor :token,
                  :logger

    def base_url
      'https://api.github.com'
    end

    def api_version
      'inertia-preview'
    end

    def logger
      @logger || Logger.new(STDOUT)
    end
  end
end
end
end
