# frozen_string_literal: true
require 'horn_of_plenty/parsers/hash'
require 'horn_of_plenty/null_objects/lane'
require 'horn_of_plenty/models/lane'

module  HornOfPlenty
module  Adapters
module  Github
module  Parsers
class   Lane
  include HornOfPlenty::Parsers::Hash

  attr_accessor :raw

  def initialize(raw:)
    self.raw = raw
  end

  def id
    @id                                    ||= parse_text(raw, 'id')
  end

  def board_id
    @board_id                              ||= parse_text(raw, 'project_url') do |url|
      url.match(%r{\A.*/(\d+)\z})[1]
    end
  end

  def title
    @title                                 ||= parse_text(raw, 'name')
  end

  def created_at
    @created_at                            ||= parse_time(raw, 'created_at')
  end

  def updated_at
    @updated_at                            ||= parse_time(raw, 'updated_at')
  end

  def self.to_model(raw_item)
    return NullObjects::Lane.instance unless raw_item

    Models::Lane.from_parser(parser: new(raw: raw_item))
  end
end
end
end
end
end
