# frozen_string_literal: true
require 'horn_of_plenty/parsers/hash'
require 'horn_of_plenty/null_objects/pull_request'
require 'horn_of_plenty/adapters/github/parsers/issue'
require 'horn_of_plenty/models/pull_request'

module  HornOfPlenty
module  Adapters
module  Github
module  Parsers
class   PullRequest < Parsers::Issue
  def labels
    []
  end

  def merger_id
    @merger_id                             ||= parse_text(raw, 'merged_by/:/login')
  end

  def status
    @status                                ||= begin
      status    = parse_text(raw, 'state')
      merged_at = parse_text(raw, 'merged_at')

      merged_at ? 'merged' : status
    end
  end

  def self.to_model(raw_item)
    return NullObjects::PullRequest.instance unless raw_item

    Models::PullRequest.from_parser(parser: new(raw: raw_item))
  end
end
end
end
end
end
