# frozen_string_literal: true
require 'horn_of_plenty/request'

module  HornOfPlenty
module  Adapters
module  Github
module  Requests
class   ListLanes < HornOfPlenty::Request
  attr_accessor :format,
                :pagination,
                :query,
                :repository

  def initialize(format:     'raw',
                 pagination: {},
                 query:      {},
                 repository:)

    self.format     = format
    self.pagination = pagination
    self.query      = query
    self.repository = repository
  end

  def method
    'get'
  end

  def path
    if query[:id]
      "repos/#{repository}/projects/columns/#{query[:id]}"
    elsif query[:board_id]
      "repos/#{repository}/projects/#{query[:board_id]}/columns"
    end
  end

  def to_h
    @to_h ||= query_class.new(query).to_h.
              merge(pagination_hash)
  end
  alias to_params to_h

  private

  def pagination_hash
    pagination.to_h
  end
end
end
end
end
end
