# frozen_string_literal: true
require 'digest'
require 'horn_of_plenty/models/parsable'

module  HornOfPlenty
module  Models
class   Board
  include Parsable

  parsable_attributes :id,
                      :author_id,
                      :title,
                      :description,
                      :created_at,
                      :updated_at
  def to_h
    {
      id:          id,
      author_id:   author_id,
      title:       title,
      description: description,
      created_at:  created_at,
      updated_at:  updated_at,
    }
  end

  def to_sha
    @sha ||= Digest::SHA2.hexdigest(to_h.to_s)
  end
end
end
end
