# frozen_string_literal: true
require 'digest'
require 'horn_of_plenty/models/parsable'

module  HornOfPlenty
module  Models
class   Card
  include Parsable

  parsable_attributes :id,
                      :lane_id,
                      :repository,
                      :status,
                      :content_type,
                      :content_id,
                      :title,
                      :description,
                      :labels,
                      :created_at,
                      :updated_at

  def labels
    @labels || []
  end

  def status
    @status || nil
  end

  def to_h
    {
      id:           id,
      lane_id:      lane_id,
      repository:   repository,
      status:       status,
      content_type: content_type,
      content_id:   content_id,
      title:        title,
      description:  description,
      labels:       labels,
      created_at:   created_at,
      updated_at:   updated_at,
    }
  end

  def to_sha
    @sha ||= Digest::SHA2.hexdigest(to_h.to_s)
  end
end
end
end
