# frozen_string_literal: true
require 'digest'
require 'horn_of_plenty/models/parsable'

module  HornOfPlenty
module  Models
class   Issue
  include Parsable

  parsable_attributes :id,
                      :author_id,
                      :assignee_ids,
                      :closer_id,
                      :repository,
                      :status,
                      :title,
                      :description,
                      :labels,
                      :closed_at,
                      :has_pull_request?,
                      :created_at,
                      :updated_at
  def to_h
    {
      id:               id,
      author_id:        author_id,
      assignee_ids:     assignee_ids,
      closer_id:        closer_id,
      repository:       repository,
      status:           status,
      title:            title,
      description:      description,
      labels:           labels,
      closed_at:        closed_at,
      has_pull_request: has_pull_request?,
      created_at:       created_at,
      updated_at:       updated_at,
    }
  end

  def to_sha
    @sha ||= Digest::SHA2.hexdigest(to_h.to_s)
  end
end
end
end
