# frozen_string_literal: true
module  HornOfPlenty
module  Parsable
  module ClassMethods
    def from_parser(parser:)
      new(parser: parser)
    end

    def parsable_attributes(*attribute_list)
      attribute_list.each do |attribute|
        instance_variable_name = "@#{attribute.to_s.gsub(/[\?]/, '')}".to_sym

        define_method attribute do
          if instance_variable_get(instance_variable_name).nil?
            parser.__send__(attribute)
          else
            instance_variable_get(instance_variable_name)
          end
        end

        define_method "#{attribute}=" do |other|
          instance_variable_set(instance_variable_name, other)
        end
      end
    end
  end

  attr_accessor :parser

  def initialize(parser: nil, **args)
    self.parser = parser

    if defined?(super) && args.empty?
      super()
    elsif defined?(super)
      super(**args)
    end
  end

  def self.included(base)
    base.extend ClassMethods
  end
end
end
