# frozen_string_literal: true
require 'horn_of_plenty/core_ext/string'

module  HornOfPlenty
module  Repositories
class   PullRequest
  def self.fetch(**attrs)
    adapter = attrs.delete(:adapter)

    adapter_class_for(adapter).fetch(**attrs)
  end

  def self.adapter_class_for(adapter)
    adapter_class_name = "HornOfPlenty::" \
                         "Adapters::" \
                         "#{HornOfPlenty::CoreExt::String.camelize(adapter)}::" \
                         "Repositories::" \
                         "PullRequest"

    require HornOfPlenty::CoreExt::String.underscore(adapter_class_name)

    HornOfPlenty::CoreExt::String.constantize(adapter_class_name)
  end
end
end
end
