# frozen_string_literal: true
require 'horn_of_plenty/paginator'

module  HornOfPlenty
class   Repository
  attr_accessor :client

  def initialize(client: nil)
    self.client = client
  end

  def fetch(**attrs)
    pagination = attrs[:pagination] || {}
    request    = fetch_class(attrs).new(**attrs)

    Paginator.new(client:         client,
                  request:        request,
                  items_per_page: pagination[:page_size],
                  current_page:   pagination[:page_number],
                  autopage:       pagination.fetch(:autopage, true))
  end

  def self.fetch(**attrs)
    client = attrs.delete(:client)

    new(client: client).fetch(attrs)
  end
end
end
