# frozen_string_literal: true
require 'horn_of_plenty/core_ext/string'

module  HornOfPlenty
class   Request
  def response_class
    @response_class ||= begin
      response_class_name             = self.class.name.gsub(/::Requests/, '::Responses')
      underscored_response_class_name = HornOfPlenty::CoreExt::String.underscore(
                                          response_class_name,
      )

      require underscored_response_class_name

      HornOfPlenty::CoreExt::String.constantize(response_class_name)
    end
  end

  def query_class
    @query_class ||= begin
      query_class_name             = self.class.name.gsub(/::Requests/, '::Queries')
      underscored_query_class_name = HornOfPlenty::CoreExt::String.underscore(
                                       query_class_name,
      )

      require underscored_query_class_name

      HornOfPlenty::CoreExt::String.constantize(query_class_name)
    end
  end
end
end
